LanguageDetectorFactory (Apache OpenNLP Tools 1.9.5 API)
Date: 2026-06-18

opennlp.tools.langdetect

## Class LanguageDetectorFactory

- java.lang.Object
- - opennlp.tools.util.BaseToolFactory
  - - opennlp.tools.langdetect.LanguageDetectorFactory

-     public class LanguageDetectorFactory
      extends BaseToolFactory

  Default factory used by Language Detector. Extend this class to change the Language Detector behaviour, such as the `LanguageDetectorContextGenerator`. The default `DefaultLanguageDetectorContextGenerator` will use char n-grams of size 1 to 3 and the following normalizers:
  - `EmojiCharSequenceNormalizer`
  - `UrlCharSequenceNormalizer`
  - `TwitterCharSequenceNormalizer`
  - `NumberCharSequenceNormalizer`
  - `ShrinkCharSequenceNormalizer`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LanguageDetectorFactory()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static LanguageDetectorFactory` | `create(String subclassName)`
    `LanguageDetectorContextGenerator` | `getContextGenerator()`
    `void` | `init()`
    `void` | `validateArtifactMap()` Validates the parsed artifacts.

    - ### Methods inherited from class opennlp.tools.util.BaseToolFactory

      `create, create, createArtifactMap, createArtifactSerializersMap, createManifestEntries`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LanguageDetectorFactory

          public LanguageDetectorFactory()

  - ### Method Detail

    - #### getContextGenerator

          public LanguageDetectorContextGenerator getContextGenerator()

    - #### create

          public static LanguageDetectorFactory create(String subclassName)
                                                throws InvalidFormatException

      Throws:
        `InvalidFormatException`

    - #### init

          public void init()

    - #### validateArtifactMap

          public void validateArtifactMap()
                                   throws InvalidFormatException

      Description copied from class: `BaseToolFactory`
      Validates the parsed artifacts. If something is not valid subclasses should throw an `InvalidFormatException`. Note: Subclasses should generally invoke super.validateArtifactMap at the beginning of this method.
      Specified by:
        `validateArtifactMap` in class `BaseToolFactory`
      Throws:
        `InvalidFormatException`

Copyright © 2026 The Apache Software Foundation. All rights reserved.